datablock CameraData(DefconControlCamera) {
   mode = "SiloPicker";
   firstPersonOnly = true;
};

function CameraMessageLoop(%cl, %obj, %mode) {
   if(!isObject(%obj)) {
      return;
   }
   if(!isObject(%cl.player) || %cl.player.getState() $= "dead") {
      %obj.delete();
      return;
   }
   switch$ (%mode) {
      case "SiloPicker":
         BottomPrint(%cl, "MOVE TO POSITION, AND PRESS JET TO CHOOSE TARGET", 1, 2);
      case "CapitolBlast" or "PlasmaStorm":
         BottomPrint(%cl, "MOVE TO POSITION, AND PRESS JET TO FIRE", 1, 2);
   }
   schedule(1000, 0, "CameraMessageLoop", %cl, %obj, %mode);
}

function DefconControlCamera::onTrigger(%data,%obj,%trigger,%state) {
   if (%state == 0)
      return;

   //first, give the game the opportunity to prevent the observer action
   if (!Game.ObserverOnTrigger(%data, %obj, %trigger, %state))
      return;

   //now observer functions if you press the "throw"
   if (%trigger >= 4)
      return;

   %client = %obj.getControllingClient();
   if (%client == 0)
      return;

   switch$ (%obj.mode) {
      case "SiloPicker":
         //press JET
         if (%trigger == 3) {
            %position = %obj.getPosition();
            if(isObject(%client.player)) {
               %obj.schedule(1000, "delete");
               %client.schedule(1, setControlObject, %client.player);
               bottomPrint(%client, "Coordinates Confirmed", 5, 2);
               %silo = %client.player.attachedObj.ControllingObj;
               %silo.targetLoc = %position;
            }
            else {
               bottomPrint(%client, "Player Object Required", 5, 2);
            }
         }
      case "CapitolBlast":
         //press JET
         if (%trigger == 3) {
            %position = %obj.getPosition();
            if(isObject(%client.player)) {
               if(%client.canFireCapitol) {
                  LaunchCapitolStrike(%client, %obj.getPosition());
                  %obj.schedule(11000, "delete");
                  %client.schedule(10000, setControlObject, %client.player);
                  bottomPrint(%client, "Coordinates Confirmed, Firing Gauss Cannons", 5, 2);
                  return;
               }
               else {
                  %obj.schedule(1000, "delete");
                  %client.setControlObject(%client.player);
                  bottomPrint(%client, "Cannot fire, Capitol Blast Charging", 5, 2);
                  return;
               }
            }
            else {
               bottomPrint(%client, "Player Object Required", 5, 2);
               return;
            }
         }
      case "PlasmaStorm":
         //press JET
         if (%trigger == 3) {
            %position = %obj.getPosition();
            if(isObject(%client.player)) {
               if(%client.canFirePlasmaStorm) {
                  LaunchPlasmaStorm(%client, %obj.getPosition());
                  %obj.schedule(11000, "delete");
                  %client.schedule(10000, setControlObject, %client.player);
                  bottomPrint(%client, "Coordinates Confirmed, Spinning plasma batteries", 5, 2);
                  return;
               }
               else {
                  %obj.schedule(1000, "delete");
                  %client.setControlObject(%client.player);
                  bottomPrint(%client, "Cannot fire, Plasma Storm Charging", 5, 2);
                  return;
               }
            }
            else {
               bottomPrint(%client, "Player Object Required", 5, 2);
               return;
            }
         }
   }
}
