datablock StaticShapeData(OrdersReticle) : StaticShapeDamageProfile {
	className = "decoration";
	shapeFile = "reticle_bomber.dts";

	maxDamage      = 0.5;
	destroyedLevel = 0.5;
	disabledLevel  = 0.3;
 
    invincible = true;

	explosion      = HandGrenadeExplosion;
	expDmgRadius = 1.0;
	expDamage = 0.05;
	expImpulse = 200;

	dynamicType = $TypeMasks::StaticShapeObjectType;
	deployedObject = true;
	cmdCategory = "DSupport";
	cmdIcon = CMDSensorIcon;
	cmdMiniIconName = "commander/MiniIcons/com_deploymotionsensor";
	targetNameTag = 'Orders';
	deployAmbientThread = true;
	debrisShapeName = "debris_generic_small.dts";
	debris = DeployableDebris;
	heatSignature = 0;
	needsPower = true;
 
    collidable = false;
};

function UnitSelectedLoop(%owner, %unit) {
   if(!isAlive(%unit)) {
      %owner.SelectedUnit = "";
      if(isObject(%owner.SelectRet)) {
         %owner.SelectRet.delete();
         return;
      }
   }
   if(!isAlive(%owner)) {
      if(isObject(%owner.SelectRet)) {
         %owner.SelectRet.delete();
         return;
      }
   }
   if(%owner.SelectedUnit != %unit) {
      if(isObject(%owner.SelectRet)) {
         %owner.SelectRet.delete();
         return;
      }
   }
   //
   if(isObject(%owner.SelectRet)) {
      %owner.SelectRet.setPosition(%unit.getPosition());
   }
   else {
      %owner.SelectRet = new StaticShape() {
         datablock = "OrdersReticle";
         position = %unit.getPosition();
         team = %unit.team;
      };
      MissionCleanup.add(%owner.SelectRet);
   }
   schedule(500, 0, "UnitSelectedLoop", %owner, %unit);
}

//TL Modifications
function TargetingLaserImage::onMount(%data, %obj, %slot) {
   %obj.TLMount = 1;
   Parent::onMount(%data, %obj, %slot);
}

function TargetingLaserImage::onUnMount(%data, %obj, %slot) {
   %obj.TLMount = 0;
   Parent::onUnMount(%data, %obj, %slot);
}

function TargetingLaserImage::onFire(%data, %obj, %slot) {
   %p = Parent::onFire(%data, %obj, %slot);
   //check if dead
   if(%obj.SelectedUnit !$= "") {
      if(!isAlive(%obj.SelectedUnit)) {
         %obj.SelectedUnit = "";
      }
   }
   //Order Of Operations, heh, this works!!
   //1. Check if a unit is selected
   //2. IF Not Selected, run the raycast
   //3. IF Selected, Perform order based on 'mine' sub-mode
   if(%obj.SelectedUnit $= "") {
      //raycast us a unit
      %muzzlePos = %obj.getMuzzlePoint(%slot);
      %muzzleVec = %obj.getMuzzleVector(%slot);
      %endPos    = VectorAdd(%muzzlePos, VectorScale(%muzzleVec, BasicTargeter.MaxRifleRange));
      %Mask = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType;

      %raycast = ContainerRayCast(%muzzlePos, %endPos, %mask, %obj);
      %hitObj = getWord(%raycast, 0);
      if(%hitObj) {
         if(%hitObj.isPlayerScriptAI && %hitObj.team == %obj.team) {
            BottomPrint(%obj.client, "Unit: "@%hitObj.nameToPush@"("@%hitObj@") Selected", 1, 1);
            %obj.SelectedUnit = %hitObj;
            UnitSelectedLoop(%obj, %hitObj);
            %hitObj.getDatablock().onSelectUnit(%hitObj, %obj);
            return;
         }
         else {
            BottomPrint(%obj.client, "Invalid, Object is not a controllable unit or, not on your team", 1, 1);
            return;
         }
      }
   }
   else {
      %muzzlePos = %obj.getMuzzlePoint(%slot);
      %muzzleVec = %obj.getMuzzleVector(%slot);
      %endPos    = VectorAdd(%muzzlePos, VectorScale(%muzzleVec, BasicTargeter.MaxRifleRange));

      %raycast = ContainerRayCast(%muzzlePos, %endPos, $AllObjMask, %obj);
      %hitObj = getWord(%raycast, 0);
      if(strstr(%obj.order[%obj.TLMineMode], "[PTO]") != -1) { //press to order has no specific location
         %obj.SelectedUnit.getDatablock().ProcessOrders(%obj.SelectedUnit, %obj.TLMineMode, "", "");
         %obj.SelectedUnit = "";
         %obj.TLMineMode = 0;
      }
      else {
         if(%hitObj) {
            %obj.SelectedUnit.getDatablock().ProcessOrders(%obj.SelectedUnit, %obj.TLMineMode, %hitObj, getWords(%raycast, 1, 3));
            %obj.SelectedUnit = "";
            %obj.TLMineMode = 0;
         }
         else {
            BottomPrint(%obj.client, "Invalid Order Position", 1, 1);
         }
      }
   }
}

function PerformTLGrenadeOps(%obj) {
   if(%obj.SelectedUnit !$= "") {
      BottomPrint(%obj.client, "Unit: "@%obj.SelectedUnit.nameToPush@"("@%obj.SelectedUnit@") De-Selected", 1, 1);
      %obj.SelectedUnit = "";
   }
}

function PerformTLMineOps(%obj) {
   if(%obj.SelectedUnit $= "") {
      BottomPrint(%obj.client, "No unit selected...", 1, 1);
      return;
   }
   %obj.TLMineMode++;
   if(%obj.order[%obj.TLMineMode] $= "") { //smart Mode
      %obj.TLMineMode = 0;
   }
   %obj.SelectedUnit.getDatablock().DisplayOrders(%obj.SelectedUnit, %obj);
}
