//UNIT: CHAINGUN SOLDIER
//COST: 500, DEFCON 5
//DESCRIPTION: CG Soldiers attack enemy units / bases

datablock PlayerData(CGSolderArmor) : LightMaleHumanArmor {
   maxDamage = 1.5;
   minImpactSpeed = 50;
   speedDamageScale = 0.015;

   speed = 2400;
};

function SpawnCGSoldier(%client) {
   %CGSoldier = new player(){
      Datablock = "CGSolderArmor";
   };
   %name = "Rifle Soldier";
   
   %CGSoldier.name = %name;

   %CGSoldier.setInventory(CombatRifle, 1, true);
//   %CGSoldier.setInventory(ChaingunAmmo, 99999, true);
   %CGSoldier.use(CombatRifle);

   %CGSoldier.target = createTarget(%CGSoldier, %name, "", "Male1", '', %CGSoldier.team, PlayerSensor);
   setTargetName(%CGSoldier.target, addtaggedstring(%name));
   setTargetSkin(%CGSoldier.target, 'SWolf');

   %CGSoldier.BearingSet = 0;

   %client.OnDeployUnit(%CGSoldier);
}

function CGSolderArmor::OnSelectUnit(%data, %CGSoldier, %obj) {
   %CGSoldier.nameToPush = "Rifle Soldier";
   %obj.order[0] = "Move [PTM]";
   %obj.order[1] = "Attack Enemy Object [PTSL]";
   %obj.order[2] = "Patrol Area [PTO]";
   %obj.order[3] = "Cancel Orders [PTO]";
}

function CGSolderArmor::DisplayOrders(%data, %unit, %obj) {
   BottomPrint(%obj.client, "Unit: "@%unit.nameToPush@"("@%unit@") \n ORDER: "@%obj.order[%obj.TLMineMode]@"", 2, 2);
}

function CGSolderArmor::ProcessOrders(%data, %CGSoldier, %orders, %hitObj, %Position) {
   if(!isAlive(%CGSoldier)) {
      return;
   }
   //
   if((%CGSoldier.orders || %CGSoldier.Patrolling) && %orders != 3) {  //we cannot do two things at once
      bottomPrint(%CGSoldier.owner, "Cannot perform a second order, must cancel first", 1, 1);
      return;
   }
   else {
      switch(%orders) {
         case 0:
            %CGSoldier.orders = 1;
            CGSoldierMove(%CGSoldier, %Position, "");
         case 1:
            if(%hitObj.team == %CGSoldier.team || %hitObj.team == 0) {
               messageClient(%CGSoldier.owner, 'msgInvalid', "\c5Rifle Soldier: That's not a legit target... sir!");
               %CGSoldier.orders = 0;
               return;
            }
            else {
               %CGSoldier.orders = 1;
               CGSoldierMove(%CGSoldier, %Position, %hitObj);
            }
         case 2:
            %CGSoldier.Patrolling = 1;
            %CGSoldier.PatrolLoop = CGSoldierPatrolLoop(%CGSoldier, %CGSoldier.getPosition());
         case 3:
            %CGSoldier.orders = 0;
            %CGSoldier.attacking = 0;
            %CGSoldier.Moving = 0;
            %CGSoldier.Patrolling = 0;
            cancel(%CGSoldier.PatrolLoop);
         default:
            echo("Invalid orders");
            return;
      }
   }
}

function CGSoldierMove(%CGSoldier, %targetLocation, %target) {
   if(!isAlive(%CGSoldier)) {
	  return;
   }
   if(!%CGSoldier.orders) {
      return;
   }
   if(%CGSoldier.attacking) {
      return;
   }
   %pos = %CGSoldier.getworldboxcenter();
   //echo(""@%pos@" - "@%targetLocation@" - "@vectorDist(%pos,%targetLocation)@"");
   %fmultiplier = %CGSoldier.getDatablock().Speed;

   if(!%target || %target $= "") {
      %vector = GetDirectionToMove(%CGSoldier, %targetLocation);

      %vector = vectorscale(%vector, %Fmultiplier);
      %x = Getword(%vector,0);
      %y = Getword(%vector,1);

      %vector = %x@" "@%y@" 0";
      %CGSoldier.applyImpulse(%pos, %vector);

      //reached target, lets move on
      if(vectorDist(%pos, %targetLocation) < 10) {
         %CGSoldier.orders = 0;
         %CGSoldier.Moving = 0;
         return;
      }

      //if(%CGSoldier.getForwardVector() $= "0 0 0") { //old method
      %muzzlePos = %CGSoldier.getEyePoint();
      %muzzleVec = %CGSoldier.getEyeVector();
      %endPos    = VectorAdd(%muzzlePos, VectorScale(%muzzleVec, 2));
      %Mask = $TypeMasks::PlayerObjectType;

      //stuck?
      %hit = ContainerRayCast(%muzzlePos, %endPos, %Mask, %CGSoldier);
      if(%hit) {
         %CGSoldier.setVelocity(""@getRandom(-5,5)@" "@getRandom(-5,5)@" "@getRandom(1,5)@"");
         //now we arent :)
      }
   }
   else {
      if(!isAlive(%target)) {
         %CGSoldier.orders = 0;
         %CGSoldier.attacking = 0;
         %CGSoldier.Moving = 0;
         %CGSoldier.setImageTrigger(0, false);
         return;
      }
      %targetLocation = %target.getPosition();
      %vector = GetDirectionToMove(%CGSoldier, %targetLocation);

      %vector = vectorscale(%vector, %Fmultiplier);
      %x = Getword(%vector,0);
      %y = Getword(%vector,1);

      %vector = %x@" "@%y@" 0";
      %CGSoldier.applyImpulse(%pos, %vector);

      //reached target, lets move on
      if(vectorDist(%pos, %targetLocation) < 75) {
         //%CGSoldier.pressFire(30);
         CGSoldierAttack(%CGSoldier, %target);
         %CGSoldier.attacking = 1;
         %CGSoldier.Moving = 0;
         return;
      }

      //if(%CGSoldier.getForwardVector() $= "0 0 0") { //old method
      %muzzlePos = %CGSoldier.getEyePoint();
      %muzzleVec = %CGSoldier.getEyeVector();
      %endPos    = VectorAdd(%muzzlePos, VectorScale(%muzzleVec, 2));
      %Mask = $TypeMasks::PlayerObjectType;

      //stuck?
      %hit = ContainerRayCast(%muzzlePos, %endPos, %Mask, %CGSoldier);
      if(%hit) {
         %CGSoldier.setVelocity(""@getRandom(-5,5)@" "@getRandom(-5,5)@" "@getRandom(1,5)@"");
         //now we arent :)
      }
   }
   %CGSoldier.moveloop = schedule(500, %CGSoldier, "CGSoldierMove", %CGSoldier, %targetLocation, %target);
}

function CGSoldierAttack(%CGSoldier, %target) {
   if(!isAlive(%target)) {
      %CGSoldier.orders = 0;
      %CGSoldier.attacking = 0;
      %CGSoldier.Moving = 0;
      %CGSoldier.setImageTrigger(0, false);
      return;
   }
   if(!isAlive(%CGSoldier)) {
      return;
   }
   //look at the target
   %vec = GetDirectionToMove(%CGSoldier, %target.getPosition());
   if(vectorDist(%CGSoldier.getPosition(), %target.getPosition()) > 125) {    //too far away
      %CGSoldier.orders = 0;
      %CGSoldier.attacking = 0;
      %CGSoldier.Moving = 0;
      %CGSoldier.setImageTrigger(0, false);
      return;
   }
   else if(vectorDist(%CGSoldier.getPosition(), %target.getPosition()) > 50) {
      %pos = %CGSoldier.getworldboxcenter();
      %fmultiplier = %CGSoldier.getDatablock().Speed;
      %vector = vectorscale(%vec, %Fmultiplier);
      %CGSoldier.applyImpulse(%pos, %vector);
      %CGSoldier.setImageTrigger(0, true);
      //serverPlay3d(ChaingunFireSound, %CGSoldier.getPosition());
   }
   else {
      //manuvers
      %manu[1] = "5 0 0";   //Right
      %manu[2] = "-5 0 0";  //Left
      %manu[3] = "0 5 0";   //Forward
      %manu[4] = "0 -5 0";  //Backward
      %rnd = getRandom(1, 4); //pick a manuver
      //perfom it
      %pos = %CGSoldier.getworldboxcenter();
      %fmultiplier = (%CGSoldier.getDatablock().Speed) / 7.4;
      %vector = vectorscale(%manu[%rnd], %Fmultiplier);
      %CGSoldier.applyImpulse(%pos, %vector);
      %CGSoldier.setImageTrigger(0, true);
   }
   //
  // serverPlay3d(ChaingunFireSound, %CGSoldier.getPosition());
   schedule(250, 0, "CGSoldierAttack", %CGSoldier, %target);
}

function CGSoldierPatrolLoop(%CGSoldier, %defendLocation) {
   if(!isAlive(%CGSoldier)) {
	  return;
   }
   if(%CGSoldier.Moving || %CGSoldier.attacking) {
      %CGSoldier.PatrolLoop = schedule(1000, 0, "CGSoldierPatrolLoop", %CGSoldier, %defendLocation);
   //   echo("moving | attacking");
      return;
   }
   else {
      if(vectorDist(%CGSoldier.getPosition(), %defendLocation) > 15) {
         %CGSoldier.Moving = 1;
         %CGSoldier.Orders = 1;
        // echo("too far, returning");
         CGSoldierMove(%CGSoldier, %defendLocation, "");
      }
      else {
         %TargetSearchMask = $TypeMasks::PlayerObjectType;
         InitContainerRadiusSearch(%CGSoldier.getPosition(), 150, %TargetSearchMask);
         while ((%potentialTarget = ContainerSearchNext()) != 0) {
            if (%potentialtarget && (%potentialTarget.team != %CGSoldier.team)) {
               %CGSoldier.Moving = 1;
               %CGSoldier.Orders = 1;
               CGSoldierMove(%CGSoldier, %potentialTarget.getPosition(), %potentialTarget);
               //echo("target aquired");
            }
         }
      }
   }
   %CGSoldier.PatrolLoop = schedule(1000, 0, "CGSoldierPatrolLoop", %CGSoldier, %defendLocation);
}
