//UNIT: CHAINGUN SOLDIER
//COST: 500, DEFCON 5
//DESCRIPTION: CG Soldiers attack enemy units / bases

datablock PlayerData(GathererGuardArmor) : LightMaleHumanArmor {
   maxDamage = 1.5;
   minImpactSpeed = 50;
   speedDamageScale = 0.015;

   speed = 2400;
};

function SpawnGathererGuard(%client) {
   %GathererGuard = new player(){
      Datablock = "GathererGuardArmor";
   };
   %name = "Gatherer Guard";

   %GathererGuard.name = %name;

   %GathererGuard.setInventory(Blaster, 1, true);
//   %GathererGuard.setInventory(ChaingunAmmo, 99999, true);
   %GathererGuard.use(Blaster);

   %GathererGuard.target = createTarget(%GathererGuard, %name, "", "Male5", '', %GathererGuard.team, PlayerSensor);
   setTargetName(%GathererGuard.target, addtaggedstring(%name));
   setTargetSkin(%GathererGuard.target, 'SWolf');

   %GathererGuard.BearingSet = 0;
   %client.OnDeployUnit(%GathererGuard);
}

function GathererGuardArmor::OnSelectUnit(%data, %GathererGuard, %obj) {
   %GathererGuard.nameToPush = "Gatherer Guard";
   %obj.order[0] = "Move [PTM]";
   %obj.order[1] = "Defend Gatherer";
   %obj.order[2] = "Cancel Orders [PTO]";
}

function GathererGuardArmor::DisplayOrders(%data, %unit, %obj) {
   BottomPrint(%obj.client, "Unit: "@%unit.nameToPush@"("@%unit@") \n ORDER: "@%obj.order[%obj.TLMineMode]@"", 2, 2);
}

function GathererGuardArmor::ProcessOrders(%data, %GathererGuard, %orders, %hitObj, %Position) {
   if(!isAlive(%GathererGuard)) {
      return;
   }
   //
   if((%GathererGuard.orders || %GathererGuard.Patrolling) && %orders != 3) {  //we cannot do two things at once
      bottomPrint(%GathererGuard.owner, "Cannot perform a second order, must cancel first", 1, 1);
      return;
   }
   else {
      switch(%orders) {
         case 0:
            %GathererGuard.orders = 1;
            GathererGuardMove(%GathererGuard, %Position, "");
         case 1:
            if(%hitObj.team != %GathererGuard.team || %hitObj.team == 0) {
               messageClient(%GathererGuard.owner, 'msgInvalid', "\c5Gatherer Guard: That's not a legit target... sir!");
               %GathererGuard.orders = 0;
               return;
            }
            else {
               %GathererGuard.orders = 1;
               GathererGuardMove(%GathererGuard, %Position, %hitObj);
            }
         case 2:
            %GathererGuard.orders = 0;
            %GathererGuard.attacking = 0;
            %GathererGuard.Moving = 0;
         default:
            echo("Invalid orders");
            return;
      }
   }
}
