//SCORE MENU FUNCTIONS
//As Well as the default (No Commander) Score Set.

//Defcon Level Costs
$DefconCost[5] = 500;
$DefconCost[4] = 1000;
$DefconCost[3] = 2000;
$DefconCost[2] = 4000;
$DefconCost[1] = 5000;

$ScoreHudMaxVisible = 16; //maybe 16 for low end people?
function DefaultGame::updateScoreHud(%game, %client, %tag){
   if (%client.SCMPage $= "")
      %client.SCMPage = 1;
   if (%client.SCMPage $= "SM")
      return;
   $TagToUseForScoreMenu = %tag;
   messageClient( %client, 'ClearHud', "", %tag, 0 );
   messageClient( %client, 'SetScoreHudHeader', "", "" );
   messageClient( %client, 'SetScoreHudHeader', "", "<a:gamelink\tGTP\t1>Commands Menu</a><rmargin:600><just:right><a:gamelink\tNAC\t1>Close</a>" );
   messageClient( %client, 'SetScoreHudSubheader', "", "Main Menu" );

   if(%client.attachedCom $= "") { //I pressed [F2]
      scoreCmdMainMenu(%game, %client, %tag, %client.SCMPage);
   }
   else {
      switch$(%client.attachedCom) {
      
         case "CommandPost":
            %game.processGameLink(%client, "CmdPostMain", 1);
            %client.SCMPage = 1;
            return;
            
         case "Outpost":
            %game.processGameLink(%client, "OutpostMain", 1);
            %client.SCMPage = 1;
            return;
            
         case "MissileSilo":
            %game.processGameLink(%client, "SiloMain", 1);
            %client.SCMPage = 1;
            return;
            
         default:
            closeScoreHudFSERV(%client);
            return;
      }
   }
}

function DefaultGame::processGameLink(%game, %client, %arg1, %arg2, %arg3, %arg4, %arg5){
   %tag = $TagToUseForScoreMenu;
   messageClient( %client, 'ClearHud', "", %tag, 1 );
   switch$ (%arg1) {
   
      case "GTP":
         scoreCmdMainMenu(%game,%client,$TagToUseForScoreMenu,%arg2);
         %client.SCMPage = 1;
         return;
         
      case "BF":
         buyFavorites(%client);
         closeScoreHudFSERV(%client);
         return;
         
      case "LoadSingeMenu":
         messageClient( %client, 'SetScoreHudSubheader', "", "Singe Gun Upgrade Panel" );
         %client.SCMPage = "Sub";
         %index = DoSingeGunUpgradeCheck(%client, %index, %tag);
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tNAC\t1>Exit</a>");
         %index++;
         return;
         
      case "BuyUpgrade":
         %upgrade = %arg2;
         %creds = %client.credits;
         %cost = $Cost::SingeGun[%upgrade];
         if(%creds < %cost) {
            MessageClient(%client, 'msgClient', "\c5Insufficient Credits: Need "@%cost@".");
            closeScoreHudFSERV(%client);
            return;
         }
         else {
            %client.credits -= %cost;
            //
            switch$(%upgrade) {
               case "MaxLoad100":
                  %client.MaxLoad = 100;
               case "MaxLoad125":
                  %client.MaxLoad = 125;
               case "MaxLoad150":
                  %client.MaxLoad = 150;
               case "MaxLoad175":
                  %client.MaxLoad = 175;
               case "MaxLoad200":
                  %client.MaxLoad = 200;
               //
               case "TicksPerGrab10":
                  %client.TicksPerGrab = 10;
               case "TicksPerGrab15":
                  %client.TicksPerGrab = 15;
               case "TicksPerGrab20":
                  %client.TicksPerGrab = 20;
            }
            //
            MessageClient('msgClient', "\c5Upgrade Complete!");
            closeScoreHudFSERV(%client);
         }
         return;
         
      case "BuyDefcon":
         %creds = %client.credits;
         %CP = %client.CP;
         %level = %CP.DefconLevel;
         //
         if(%level == 1) {
            return; //no idea how you got here... oh well
         }
         %cost = $DefconCost[%level-1];
         if(%creds < %cost) {
            MessageClient(%client, 'msgClient', "\c5Insufficient Credits: Need "@%cost@".");
            closeScoreHudFSERV(%client);
            return;
         }
         else {
            %client.credits -= %cost;
            %client.CP.DefconLevel--;
            MessageClient(%client, 'msgClient', "\c5DEFCON LEVEL UPGRADED TO DEFCON "@%CP.DefconLevel@", You now have "@%client.credits@" credits.");
            MessageAll('MsgAlert', "\c5DEFCON ALERT: "@%client.namebase@" has rasied to DEFCON "@%CP.DefconLevel@"! ~wfx/misc/red_alert_short.wav");
            closeScoreHudFSERV(%client);
            return;
         }
         return;
         
      case "Relocate":
         if(%client.commander !$= "") {
            MessageClient(%client, 'msgClient', "\c5Cannot relocate now, you already have a commander.");
            closeScoreHudFSERV(%client);
            return;
         }
         MessageClient(%client, 'msgClient', "\c5Relocating, standby.");
         %group = nameToID("DefconArmy"@%client@"");
         for(%i = 0; %i < %group.getCount(); %i++) {
            %obj = %group.getObject(%i);
            %obj.delete();
         }
         %group.delete();
         %game.FindInitialPoint(%client);
         closeScoreHudFSERV(%client);
         return;
         
      case "Surrender":
         MessageAll('MsgByeBye', "\c5DEFCON: "@%client.namebase@" has surrendered, all of his aspects are now being deleted ~wfx/misc/red_alert_short.wav");
         Surrender(%client);
         closeScoreHudFSERV(%client);
         return;
         
      case "Options":
         %client.SCMPage = "Sub";
         messageClient( %client, 'SetScoreHudSubheader', "", "Other Commands and Options" );
         messageClient( %client, 'SetLineHud', "", %tag, %index, "Additional Options");
         %index++;
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSurrender\t1>Surrender (THIS CANNOT BE UNDONE)</a>");
         %index++;
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tNAC\t1>Exit</a>");
         %index++;
         return;
         
      case "BuyUnit":
         if(!isObject(%client.player.attachedObj.main)) {
            MessageClient(%client, 'msgClient', "\c5You must be on a computer station.");
            closeScoreHudFSERV(%client);
            return;
         }
         %creds = %client.credits;
         switch$(%arg2) {
            case "Collector":
               %cost = %arg4;
               //
               if(%creds < %cost) {
                  MessageClient(%client, 'msgClient', "\c5Insufficient Credits: Need "@%cost@".");
                  closeScoreHudFSERV(%client);
                  return;
               }
               else {
                  SpawnCollector(%client, %arg3);
                  closeScoreHudFSERV(%client);
                  %client.credits -= %cost;
               }
            case "Scout":
               %cost = %arg3;
               if(%creds < %cost) {
                  MessageClient(%client, 'msgClient', "\c5Insufficient Credits: Need "@%cost@".");
                  closeScoreHudFSERV(%client);
                  return;
               }
               else {
                  SpawnScout(%client);
                  closeScoreHudFSERV(%client);
                  %client.credits -= %cost;
               }
            case "Seeker":
               %cost = %arg3;
               if(%creds < %cost) {
                  MessageClient(%client, 'msgClient', "\c5Insufficient Credits: Need "@%cost@".");
                  closeScoreHudFSERV(%client);
                  return;
               }
               else {
                  SpawnSeeker(%client);
                  closeScoreHudFSERV(%client);
                  %client.credits -= %cost;
               }
            case "CGSoldier":
               %cost = %arg3;
               if(%creds < %cost) {
                  MessageClient(%client, 'msgClient', "\c5Insufficient Credits: Need "@%cost@".");
                  closeScoreHudFSERV(%client);
                  return;
               }
               else {
                  SpawnCGSoldier(%client);
                  closeScoreHudFSERV(%client);
                  %client.credits -= %cost;
               }
            case "DiscSoldier":
               %cost = %arg3;
               if(%creds < %cost) {
                  MessageClient(%client, 'msgClient', "\c5Insufficient Credits: Need "@%cost@".");
                  closeScoreHudFSERV(%client);
                  return;
               }
               else {
                  SpawnDiscSoldier(%client);
                  closeScoreHudFSERV(%client);
                  %client.credits -= %cost;
               }
         }
         return;
         
      case "TargetPicker":
         switch(%arg2) {
            case 0: //missile silo
               %mode = "SiloPicker";
            case 1:
               %mode = "CapitolBlast";
            case 2:
               %mode = "PlasmaStorm";
         }
         closeScoreHudFSERV(%client);
         %Cam = new Camera() {
            dataBlock = DefconControlCamera;
         };
         MissionCleanup.add(%Cam);
         %Cam.setTransform(%client.player.getTransform());
         %Cam.setFlyMode();
         %Cam.mode = ""@%mode@"";
         %client.setControlObject(%Cam);
         CameraMessageLoop(%client, %Cam, %Cam.mode);
         return;

      case "BuySilo":
         if(%client.player.getMountedImage($Backpackslot) !$= "")
   	        %client.getControlObject().throwPack();
	     %client.player.setinventory(MissileSiloPack,1,true);
         closeScoreHudFSERV(%client);
         return;
         
      case "BuyMissile":
         %silo = %client.player.attachedObj.ControllingObj;
         %creds = %client.credits;
         if(%arg2 $= "Nuclear Missile") {
            %cost = 5000;
            %ld = 19;
         }
         else if(%arg2 $= "Swarm Missile") {
            %cost = 500;
            %ld = 16;
         }
         else if(%arg2 $= "Ultimanium Missile") {
            %cost = 10000;
            %ld = 18;
         }
         else if(%arg2 $= "Dark Hole Bomb") {
            %cost = 10000;
            %ld = 20;
         }
         //
         if(%creds < %cost) {
            MessageClient(%client, 'msgClient', "\c5Insufficient Credits: Need "@%cost@".");
            closeScoreHudFSERV(%client);
            return;
         }
         else {
            %silo.missile = ""@%arg2@"";
            %silo.load = %ld;
            closeScoreHudFSERV(%client);
            %client.credits -= %cost;
            MessageClient(%client, 'msgClient', "\c5Silo Armed with "@%arg2@".");
         }
         return;

      case "FireMissile":
         %silo = %client.player.attachedObj.ControllingObj;
         %silo.LaunchSiloMissile();
         closeScoreHudFSERV(%client);
         return;
            
      case "SiloMain" :
         %client.SCMPage = "Sub";
         messageClient( %client, 'SetScoreHudSubheader', "", "Computer Terminal: Missile Silo" );
         %silo = %client.player.attachedObj.ControllingObj;
         if(%silo.missile $= "") {
            messageClient( %client, 'SetLineHud', "", %tag, %index, "No Loaded Missile");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyMissile\tSwarm Missile\t1>Arm Swarm Missile (500 Credits)</a>");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyMissile\tNuclear Missile\t1>Arm Nuclear Missile (5000 Credits)</a>");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyMissile\tUltimanium Missile\t1>Arm Ultimanium Missile (10000 Credits)</a>");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyMissile\tDark Hole Bomb\t1>Arm Dark Hole Bomb (10000 Credits)</a>");
            %index++;
         }
         else {
            messageClient( %client, 'SetLineHud', "", %tag, %index, "Armed: "@%silo.missile@"");
            %index++;
            if(%silo.targetLoc $= "") {
               messageClient( %client, 'SetLineHud', "", %tag, %index, "No Target Set");
               %index++;
               messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tTargetPicker\t0\t1>Choose Target Location</a>");
               %index++;
            }
            else {
               messageClient( %client, 'SetLineHud', "", %tag, %index, "Target Locked : "@%silo.targetLoc@"");
               %index++;
               messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tTargetPicker\t0\t1>Choose a Different Target Location</a>");
               %index++;
               messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tFireMissile\t1>LAUNCH!!!</a>");
               %index++;
            }
         }
         messageClient( %client, 'SetLineHud', "", %tag, %index, "");
         %index++;
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tNAC\t1>Exit</a>");
         %index++;
         return;
         
      case "Units":
         %client.SCMPage = "Sub";
         messageClient( %client, 'SetScoreHudSubheader', "", "Computer Terminal: Deploy Units" );
         %index = GetUnitSet(%client, %index, %tag);
         messageClient( %client, 'SetLineHud', "", %tag, %index, "");
         %index++;
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tNAC\t1>Exit</a>");
         %index++;
         return;
         
      case "SetCmdr":
         %client.setCommander(%arg2);
         closeScoreHudFSERV(%client);
         return;
         
      case "OutpostMain":
         messageClient( %client, 'SetScoreHudSubheader', "", "Computer Terminal: Outpost" );
         %cmd = %client.getCommander();
         if(%cmd $= "None") {
            %cmd = ""@%client.namebase@"";
         }
         if(%cmd $= "") { //none Set
            messageClient( %client, 'SetLineHud', "", %tag, %index, "Welcome to defcon, please choose a commander.");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSetCmdr\tAnderson\t1>Commander Anderson</a>");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSetCmdr\tDalhart\t1>Commander Dalhart</a>");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSetCmdr\tListette\t1>Commander Listette</a>");
            %index++;
            if(%client.isSuperAdmin) {
               messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSetCmdr\tPhantom\t1>Commander Phantom [SA]</a>");
               %index++;
            }
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSetCmdr\tNone\t1>No Commander</a>");
            %index++;
         }
         else {
            %index = DoOutpostMenu(%client, %index, %tag);
         }
         return;

      case "CmdPostMain":
         messageClient( %client, 'SetScoreHudSubheader', "", "Computer Terminal: Command Post" );
         %cmd = %client.getCommander();
         if(%cmd $= "None") {
            %cmd = ""@%client.namebase@"";
         }
         if(%cmd $= "") { //none Set
            messageClient( %client, 'SetLineHud', "", %tag, %index, "Welcome to defcon, please choose a commander.");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSetCmdr\tAnderson\t1>Commander Anderson</a>");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSetCmdr\tDalhart\t1>Commander Dalhart</a>");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSetCmdr\tListette\t1>Commander Listette</a>");
            %index++;
            if(%client.isSuperAdmin) {
               messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSetCmdr\tPhantom\t1>Commander Phantom [SA]</a>");
               %index++;
            }
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSetCmdr\tNone\t1>No Commander</a>");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "");
            %index++;
            messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tRelocate\t1>Relocate Command Post</a>");
            %index++;
         }
         else {
            %index = DoCommandPostMenu(%client, %index, %tag);
         }
         return;
         
      case "BuyOutpost":
         %creds = %client.credits;
         %cost = 3000;
         //
         if(%creds < %cost) {
            MessageClient('msgClient', "\c5Insufficient Credits: Need "@%cost@".");
            closeScoreHudFSERV(%client);
            return;
         }
         else {
            %pos = vectorAdd(%client.CP.getPosition(), "15 15 7");
            %obj = new WheeledVehicle() {
               datablock  = OutpostVehicle;
               teamBought = %client.team;
               team = %client.team;
            };
            %obj.setPosition(%pos);
            closeScoreHudFSERV(%client);
            %client.credits -= %cost;
            //
            %group = nameToID("DefconArmy"@%client@"");
            if(%group != -1) {
               %group.add(%obj);
            }
            else {
               %group = new SimGroup("DefconArmy"@%client@"");
               %group.add(%obj);
               error("Outpost: client simgroup not found, making it.");
            }
         }
         return;
         
      case "SendAlly":
         %targ = %arg2;
         messageClient(%targ, 'Msgalert', "\c5ALLIANCE: "@%client.namebase@" has sent an alliance request!!! ~wfx/misc/red_alert_short.wav");
         messageClient(%targ, 'Msgalert', "\c5You can Accept Or Decline this at your command post Computer Station");
         %client.allianceRequest[%targ] = true;
         closeScoreHudFSERV(%client);
         return;
      
      case "AcceptAlly":
         //oh boy
         %targ = %arg2;
         messageClient(%targ, 'Msgalert', "\c5ALLIANCE: "@%client.namebase@" has accepted your alliance request!!! ~wfx/misc/red_alert_short.wav");
         messageClient(%client, 'Msgalert', "\c5ALLIANCE: You are now joining "@%targ.namebase@"'s army. ~wfx/misc/red_alert_short.wav");
         %client.team = %targ.team;
         //start with pieces
         %group = nameToID("MissionCleanup/Deployables");
         %count = %group.getCount();
	     for(%i=0;%i<%count;%i++) {
		    %obj = %group.getObject(%i);
            if(%obj.owner == %client) {
               %obj.team = %targ.team;
               setTargetSensorGroup(%obj.getTarget(),%client.team);
            }
         }
         //
         //Now onto my aspects
         %group2 = nameToID("DefconArmy"@%client@"");
         %count2 = %group2.getCount();
	     for(%i=0;%i<%count2;%i++) {
		    %obj2 = %group2.getObject(%i);
            %obj2.team = %targ.team;
            setTargetSensorGroup(%obj2.getTarget(),%client.team);
         }
         //Do I own any spires?
         %group3 = nameToID("DefconResources");
         %count3 = %group3.getCount();
	     for(%i=0;%i<%count3;%i++) {
		    %obj3 = %group3.getObject(%i);
            if(%obj3.team == %client.team) {
               %obj3.team = %targ.team;
               setTargetSensorGroup(%obj3.getTarget(), %targ.team);
            }
         }
         //
         //and lastly, myself
         setTargetSensorGroup(%client.target, %targ.team);
         setTargetSensorGroup(%client.getTarget(), %targ.team);
         %client.player.scriptKill(0);
         //
         closeScoreHudFSERV(%client);
         return;

      case "DenyAlly":
         %targ = %arg2;
         messageClient(%targ, 'Msgalert', "\c5ALLIANCE: "@%client.namebase@" has denied your alliance request!!! ~wfx/misc/red_alert_short.wav");
         %targ.allianceRequest[%client] = false;
         closeScoreHudFSERV(%client);
         return;
         
      case "AllianceMain":
         %client.SCMPage = "Sub";
         messageClient( %client, 'SetScoreHudSubheader', "", "Alliances" );
         messageClient( %client, 'SetLineHud', "", %tag, %index, "BE AWARE: once an alliance is made, it may not be broken");
         %index++;
         messageClient( %client, 'SetLineHud', "", %tag, %index, "BE AWARE: once you send a request, it cannot be taken back!");
         %index++;
         messageClient( %client, 'SetLineHud', "", %tag, %index, "");
         %index++;
         for(%i = 0; %i < ClientGroup.getCount(); %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team != %client.team && %cl != %client) {
               if(%cl.allianceRequest[%client] == true) {
                  messageClient( %client, 'SetLineHud', "", %tag, %index, "");
                  %index++;
                  messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tAcceptAlly\t"@%cl@"\t1>Accept Alliance from "@%cl.namebase@"</a>");
                  %index++;
                  messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tDenyAlly\t"@%cl@"\t1>Deny Alliance from "@%cl.namebase@"</a>");
                  %index++;
                  messageClient( %client, 'SetLineHud', "", %tag, %index, "");
                  %index++;
               }
               else {
                  messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tSendAlly\t"@%cl@"\t1>Send Alliance Offer to "@%cl.namebase@"</a>");
                  %index++;
               }
            }
         }
         messageClient( %client, 'SetLineHud', "", %tag, %index, "");
         %index++;
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tNAC\t1>Exit</a>");
         %index++;
         return;
         //-------------
             
      default:
   }
   closeScoreHudFSERV(%client);
}

function closeScoreHudFSERV(%client) {
   serverCmdHideHud(%client, 'scoreScreen');
   commandToClient(%client, 'setHudMode', 'Standard', "", 0);
   %client.SCMPage = 1;
}

function scoreCmdMainMenu(%game,%client,%tag,%page) {
   messageClient( %client, 'ClearHud', "", %tag, 1 );
   if (!isobject(cmdobject)) generateCMDObj();
      messageClient( %client, 'SetScoreHudSubheader', "", "Main Menu Page " @ %page);
   if (%page > 1) {
      %pgToGo = %page - 1;
      messageClient( %client, 'SetLineHud', "", %tag, %index, '<a:gamelink\tGTP\t%1>Previous Page</a>',%pgToGo);
      %index++;
   }
   %cmdsToDisp = 15 * %page;
   %start = (%page - 1) * 15;
   for (%i=%start; %i < %cmdsToDisp;%i++) {
      %line = CmdObject.cmd[%i];
      if (%line $= "BlankLine") {
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<Font:Arial:14>");
         %index++;
      }
      else if (%line !$= "") {
         messageClient( %client, 'SetLineHud', "", %tag, %index, '<a:gamelink\t%1>%2</a>',getword(%line,0),getwords(%line,1));
         %index++;
      }
  }
  if (%cmdsToDisp < (CmdObject.commands + 1)) {
     %pgToGo = %page + 1;
     messageClient( %client, 'SetLineHud', "", %tag, %index, '<a:gamelink\tGTP\t%1>Next Page</a>',%pgToGo);
     %index++;
  }
  if (%page > 1) {
     messageClient( %client, 'SetLineHud', "", %tag, %index, "<Font:Arial:14><a:gamelink\tGTP\t1>First Page</a>");
     %index++;
  }
  messageClient( %client, 'ClearHud', "", %tag, %index );
}


//format
//CMD indentifier displayname
//CMDHELP identifier help message for cmd gonna implement it
//after noobs get their hands on the base script first

function GenerateCMDObj() {
   new fileobject("fIn");
   fIn.openforread("scripts/defcon/cmddisplaylist.txt");
   if (isobject(cmdobject))
      cmdobject.delete();
   new scriptObject("CmdObject") {
      commands=0;
   };
   while (!fIn.iseof()) {
      %line = fIn.readline();
      if (getword(%line,0) $= "CMD") {
         CmdObject.cmd[CmdObject.commands] = getwords(%line,1);
         CmdObject.commands++;
      }
      else if (getword(%line,0) $= "BL") {
         CmdObject.cmd[CmdObject.commands] = "BlankLine";
         CmdObject.commands++;
      }
   }
   fIn.close();
   fIn.delete();
}
